/*
	Copyright (c) 2006-2010, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.catalog.widget.productLastViewed $Revision: 1.6 $

*/

dojo.provide('epages.cartridges.de_epages.catalog.widget.ProductLastViewed');
dojo.require('dijit._Widget');
dojo.require("epages.templated");

(function(dj){

	dj.declare( 'epages.cartridges.de_epages.catalog.widget.ProductLastViewed', [dijit._Widget,epages.Templated] , {

		_productItems : undefined,		// object - hash of last viewed product items

		postMixInProperties: function(){
			this.addTemplate('<div class="ContextBoxBody">\
													<div class="ImageContainerXS" dojoAttachpoint="imageContainer">\
														<img dojoAttachpoint="itemImage" style="width:100%; height:auto;" src="#" ></img>\
													</div>\
													<a dojoAttachpoint="itemTitle" href="javascript:void()" onclick="return false;"></a>\
													<div class="ClearBoth"></div>\
												</div>', 'productItem' );
			this._productItems = epages.localStorage.getItem('Catalog::ProductLastViewed.list');
		},

		postCreate: function(){
			dojo.addClass(this.domNode, 'ProductLastViewed');
			var tstamp,
				tstampMap = [],
				tstampHash = {};
			
			for( var i in this._productItems ){
				tstamp = this._productItems[i].tstamp;
				tstampMap.push( tstamp );
				tstampHash[ tstamp ] = this._productItems[i];
			}
			tstampMap = tstampMap.sort().reverse();
			
			for( var i=0,iLength=Math.min(this.maxItems,tstampMap.length) ; i<iLength ; i++ ){
				var product = tstampHash[tstampMap[i]],
					nodes = this.getTemplate('productItem');

				dojo.connect( nodes.domNode, 'click', product, function(event){
					location.href = epages.vars.BaseUrl + '?ObjectPath=' + this.objectPath;
				});

				nodes.itemTitle.innerHTML = product.name;
				nodes.itemTitle.href=epages.vars.BaseUrl + '?ObjectPath=' + product.objectPath;
				if(product.image) {
					nodes.itemImage.src = epages.vars.StoreWebRoot + '/' + product.image;
				} else {
					nodes.imageContainer.style.display="none";
				}

				dj.place( nodes.domNode, this.domNode, 'append' );
			}
		}

	});

})(dojo);