dojo.provide('epages.cartridges.de_epages.externalcontent.fblikebox');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.widget.Message');
dojo.require('epages.widget.Modaldialog');
dojo.require('epages.io.translation');

epages.cartridges.de_epages.externalcontent.fblikebox = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.fblikebox,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass		:	'epages.cartridges.de_epages.externalcontent.fblikebox',
	title						:	'Facebook Like-Box',
	preview					:	epages.vars.StoreRoot + '/BO/icons/navelement_fb-likebox.png',
	directPreview		:	false,
	messageWidget		:	undefined,
	translation			:	new epages.io.Translation(dojo.moduleUrl('epages.cartridges.de_epages.externalcontent', "templates/translation"), "auto"),

	url							: '',
	width						: '250',
	colorscheme			: 'light',
	connections			:	'10',
	stream					: 'true',
	header					: 'true',

	info: function () {
		var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);
		dojo.mixin(info, {
			url					: this.url,
			width				: this.width,
			colorscheme	:	this.colorscheme,
			connections	:	this.connections,
			stream			:	this.stream,
			header			: this.header
		});
		return info;
	},

	saveForm: function() {
		if (this.form !== undefined){
			this.formData = (new epages.html.Form(this.form)).get();
		}

		if( this.formData.get("fblikebox_url")[0] && this.formData.get("fblikebox_url")[0] !== "" ) {
			this.url = this.formData.get("fblikebox_url")[0];
		} else {
			this.url = "";
		}
		if( this.formData.get("fblikebox_width")[0] && this.formData.get("fblikebox_width")[0] !== "" ) {
			this.width = this.formData.get("fblikebox_width")[0];
		}
		if( this.formData.get("fblikebox_colorscheme")[0] && this.formData.get("fblikebox_colorscheme")[0] !== "" ) {
			this.colorscheme = this.formData.get("fblikebox_colorscheme")[0];
		}
		if( this.formData.get("fblikebox_connections")[0] && this.formData.get("fblikebox_connections")[0] !== "" ) {
			this.connections = (this.formData.get("fblikebox_connections")[0] <= 100) ? this.formData.get("fblikebox_connections")[0] : 100;
		} else {
			this.connections = 10;
		}

		if( this.formData.get("fblikebox_stream")[0] && this.formData.get("fblikebox_stream")[0] === "on" ) {
			this.stream = 'true';
		} else {
			this.stream = 'false';
		}
		if( this.formData.get("fblikebox_header")[0] && this.formData.get("fblikebox_header")[0] === "on" ) {
			this.header = 'true';
		} else {
			this.header = 'false';
		}
	},

	contentString: function (info, ispreview) {
		if (info === undefined){
			info = this.info();
		}
		if ( this.url !== "" ){
			var height = '556';
			if ( this.header == 'false' && this.stream == 'false'  ) {
				if ( this.connection == 0 ) {
					height = '63';
				} else {
					if( this.width == 200 ) {
						if ( this.connections < 4 ){
							height = '180';
						} else {
							height = '254';
						}
					} else if( this.width == 250 ) {
						if ( this.connections < 5 ){
							height = '180';
						} else {
							height = '254';
						}
					} else if( this.width == 300 ) {
						if ( this.connections < 6 ){
							height = '180';
						} else {
							height = '254';
						}
					} else if( this.width == 350 ) {
						if ( this.connections < 7 ){
							height = '180';
						} else {
							height = '254';
						}
					}	else {
						height = '180';
					}
				}
			}

			return '<iframe src="http://www.facebook.com/plugins/likebox.php?href='+ encodeURIComponent(this.url) +'&amp;width='+ this.width +'&amp;colorscheme='+ this.colorscheme +'&amp;connections='+ this.connections +'&amp;stream='+ this.stream +'&amp;header='+ this.header + '&amp;height='+ height + '" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:' + this.width + 'px;height:'+ height + 'px;" allowTransparency="true"></iframe>';
		} else {
			urlInput = dojo.query('input[name="fblikebox_url"]')[0];
			dojo.addClass(urlInput, "Mandatory");
			return '';
		}
	}
});